/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/

#ifdef CLIENT

#include "ulengine.h"
#include <math.h>

/* call it after rendering, and it'll apply fog. 
This is a partial first implementation, V E R Y  slow.*/
void doFog ( void ) { 
	sInt		i, j;
	dFloat		l, d = (engpref.fog.far-engpref.fog.near);
	
	if ( engpref.fog.type != NONE )
		return;

	if ( engpref.fog.far == 0 ) {
		if ( db == False ) {
			ggiSetGCForeground( vis, ggiMapColor( vis, &engpref.fog.color ) );
			ggiFillscreen( vis );
		}
		else {}
		return;
	}

	switch ( engpref.fog.type ) {
		case NONE:
			return;
		case LINEAR:
			for ( i = 0; i < mode.visible.y; i++ )
			  for ( j = 0; j < mode.visible.x; j++ ) {
				if ( frame.zbuf[i][j] <= engpref.fog.near )
					continue;
				else if ( frame.zbuf[i][j] > engpref.fog.far ) {
					copyColor( &frame.color[i][j], &engpref.fog.color );
					continue;
				}
				/* calculate fog. Not optimized yet. */
				l = (engpref.fog.far-frame.zbuf[i][j])/d;

				frame.color[i][j] = RGBAtoColor( 
					(uShort)round(frame.color[i][j].r*(1-l)+engpref.fog.color.r*l),
					(uShort)round(frame.color[i][j].g*(1-l)+engpref.fog.color.g*l),
					(uShort)round(frame.color[i][j].b*(1-l)+engpref.fog.color.b*l),
					(uShort)round(frame.color[i][j].a*(1-l)+engpref.fog.color.a*l) );
			  }
			return;
		case EXP:
			for ( i = 0; i < mode.visible.y; i++ )
			  for ( j = 0; j < mode.visible.x; j++ ) {
				if ( frame.zbuf[i][j] <= engpref.fog.near )
					continue;
				else if ( frame.zbuf[i][j] > engpref.fog.far ) {
					copyColor( &frame.color[i][j], &engpref.fog.color );
					continue;
				}

				/* calculate fog */
			  }
			return;
		case EXP2:
			for ( i = 0; i < mode.visible.y; i++ )
			  for ( j = 0; j < mode.visible.x; j++ ) {
				if ( frame.zbuf[i][j] <= engpref.fog.near )
					continue;
				else if ( frame.zbuf[i][j] > engpref.fog.far ) {
					copyColor( &frame.color[i][j], &engpref.fog.color );
					continue;
				}

				/* calculate fog */
			  }
			return;
	}
}

ggi_color fogcolor ( void ) {
	return engpref.fog.color;
}

/* pass negative values for near and far to not use them, NULL to not set
color */
#define NEARFOG		0.05
#define FARFOG		0.8
void setFog ( FOGTYPE_UL type, ggi_color *color, dFloat near, dFloat far ) {
	engpref.fog.type = type;
	if ( color )
		memcpy( &engpref.fog.color, color, sizeof(ggi_color));
	if ( near >= 0 )
		engpref.fog.near = near;
	else
		engpref.fog.near = NEARFOG;
	if ( far >= 0 )
		engpref.fog.far = far;
	else
		engpref.fog.far = FARFOG;
}


#endif
